package meerkat.registry;

import meerkat.protobuf.BulletinBoardAPI.FilterType;
import meerkat.protobuf.BulletinBoardAPI.MessageFilter;
import meerkat.protobuf.BulletinBoardAPI.MessageFilterList;

import java.util.List;

/**
 * TODO: add logging to this utils
 */

/**
 * Created by Vladimir Eliezer Tokarev  on 1/15/2016.
 * adds extra functionality to Messages collections
 */
public abstract class MessageCollectionUtils {
    /**
     * Creates list of filters based on given list of strings (that are tags)
     *
     * @param tags the tags based on which the messages will be filtered
     * @return MessageFilterList.
     */
    public static MessageFilterList GenerateFiltersFromTags(List<String> tags) {
        MessageFilterList.Builder filters = MessageFilterList.newBuilder();

        if (tags.isEmpty()){
            return filters.build();
        }

        for (String tag : tags) {
            MessageFilter filter = MessageFilter.newBuilder().setTag(tag).setType(FilterType.TAG).build();
            filters.addFilter(filter);
        }
        return filters.build();
    }
}
