package meerkat.registry;

import com.google.common.util.concurrent.FutureCallback;
import meerkat.VoterRegistry;

/**
 * TODO: add logging
 */

/**
 * Created by Vladimir Eliezer Tokarev  on 2/19/2016.
 * Handles the the after post state of VoterRegistry methods (that uses bulletinBoardClient to communicate with the server)
 */
public class MessagesCallBack implements FutureCallback<Boolean>
{
    public VoterRegistry.RegistryCallBack callback;

    /**
     * Init MessagesCallBack
     * @param callback  voter registry callback object
     */
    public MessagesCallBack(VoterRegistry.RegistryCallBack callback) {
        this.callback = callback;
    }

    /**
     * Calls the callback HandleResult method with passed object from bulletinBoardClient when
     *       the action succeed
     *
     * @param msg the message that the bulletinBoardClient passes to the callback
     */
    @Override
    public void onSuccess(Boolean msg) {
        callback.HandleResult(msg);
    }

    /**
     * Calls the callback HandleResult method with false because the post method failed
     * @param t the exception data that have been thrown during the failure of the post method
     */
    @Override
    public void onFailure(Throwable t) {
        callback.HandleFailure(t);
    }
}
